SystemOrganization addCategory: #'Glamour-EyeSee-Presentations'!

GLMParameterizableExamplesBrowser subclass: #GLMEyeSeeExamplesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-EyeSee-Presentations'!

!GLMEyeSeeExamplesBrowser commentStamp: 'TudorGirba 9/9/2012 02:44' prior: 0!
self new openOn: ESExamples!

!GLMEyeSeeExamplesBrowser class methodsFor: 'instance creation' stamp: 'TudorGirba 9/9/2012 02:55'!
open 
	^ self new openOn: ESExamples! !

!GLMEyeSeeExamplesBrowser methodsFor: 'hooks' stamp: 'TudorGirba 9/9/2012 02:43'!
exampleSelectorsFromClass: exampleClass
	^ exampleClass selectors select: [ :each | each endsWith: 'With:' ]! !

!GLMEyeSeeExamplesBrowser methodsFor: 'building' stamp: 'TudorGirba 5/21/2013 21:54'!
installTitle
	browser title: 'EyeSee Examples'! !

!GLMEyeSeeExamplesBrowser methodsFor: 'hooks' stamp: 'TudorGirba 9/9/2012 02:45'!
renderedExampleIn: composer
	composer eyesee
		title: 'Example';
		diagram: [ :renderer :exampleClass :exampleSelector | exampleClass new perform: exampleSelector with: renderer ]! !

!GLMMorphicRenderer methodsFor: '*Glamour-EyeSee-Presentations' stamp: 'TudorGirba 4/12/2011 10:33'!
renderEyeSeePresentation: aPresentation
	^ GLMMorphicEyeSeeRenderer render: aPresentation from: self! !

GLMScriptingEditorTemplate subclass: #GLMEyeSeeEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-EyeSee-Presentations'!

!GLMEyeSeeEditor commentStamp: 'TudorGirba 12/28/2011 23:34' prior: 0!
This browser offers a Glamour-based editor for EyeSee charts.

Example:
self openOn: {#variable->'value'}

This will open the editor with a variable named #variable whose value will be 'value'.!

!GLMEyeSeeEditor methodsFor: 'building' stamp: 'TudorGirba 10/8/2011 19:57'!
defaultScriptBindings
	^ {#chart -> ESDiagramRenderer new}! !

!GLMEyeSeeEditor methodsFor: 'building' stamp: 'TudorGirba 6/5/2013 22:19'!
defaultScriptDisplayIn: aPresentation
	^ aPresentation 
		display: 'chart';
		morphicAct: [:text | GLMEyeSeeExamplesBrowser open ] 
			icon: GLMUIThemeExtraIcons glamorousExample 
			entitled: 'Browse basic examples'! !

!GLMEyeSeeEditor methodsFor: 'building' stamp: 'TudorGirba 10/8/2011 19:57'!
defaultTitle
	^ 'EyeSee Editor'! !

!GLMEyeSeeEditor methodsFor: 'building' stamp: 'VincentBlondeau 2/14/2014 14:58'!
getDiagramRenderer: renderer bindings: bindings scripts: script
	| context diagramRenderer |
	context := GLMDoItContext with: #chart -> renderer withAll: bindings.
	^ [ 
	diagramRenderer := (Smalltalk compiler requestor: self) evaluate: script in: context to: context.
	[ diagramRenderer diagram ifNil: [ Error signal: 'The Diagram was not initialized' ] ] onDNU: #diagram do: [ ] ]
		on: Error
		do: [ :e | 
			self inform: e class name , ': ' , e messageText.
			renderer pieDiagram
				radius: 100;
				models: #('Error');
				pieValue: [ :x | 100 ];
				displayLegend: true;
				defaultColor: Color red ]! !

!GLMEyeSeeEditor methodsFor: 'building' stamp: 'VincentBlondeau 2/14/2014 14:34'!
resultIn: a
	^ a eyesee
		title: 'Chart';
		diagram: [ :renderer :bindings :script | self getDiagramRenderer: renderer bindings: bindings scripts: script ];
		defaultActions! !

!GLMCompositePresentation methodsFor: '*glamour-eyesee-presentations' stamp: 'TudorGirba 1/2/2012 01:15'!
eyesee
	^ self custom: GLMEyeSeePresentation new! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicEyeSeeRenderer
	instanceVariableNames: 'canvasScrollPane eyeseeCanvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-EyeSee-Presentations'!

!GLMMorphicEyeSeeRenderer methodsFor: 'private' stamp: 'TudorGirba 4/12/2011 11:28'!
actOnContextChanged: ann
	"ann property = #selection ifTrue: [ 
		eyeseeCanvas selected: (eyeseeCanvas root deepFindNodeWithEntity: ann value) ]"! !

!GLMMorphicEyeSeeRenderer methodsFor: 'private' stamp: 'TudorGirba 4/12/2011 11:08'!
actOnPresentationUpdate: ann
	ann presentation diagram: ESDiagramRenderer new.
	canvasScrollPane scroller removeMorph: canvasScrollPane scroller submorphs first.
	self eyeseeCanvasFor: ann presentation! !

!GLMMorphicEyeSeeRenderer methodsFor: 'private' stamp: 'TudorGirba 4/19/2011 13:34'!
eyeseeCanvasFor: aPresentation
	| eyeseeRenderer |
	eyeseeRenderer := aPresentation eyeseeRenderer.
	aPresentation renderOn: eyeseeRenderer.
	eyeseeRenderer interaction 
			when: ESElementSelection
			do: [ :ann | aPresentation selection: ann element ].
	eyeseeRenderer interaction 
			when: ESElementDeselection
			do: [ :ann | aPresentation status: ann element ].
	eyeseeRenderer interaction 
			when: ESMouseLeave
			do: [ :ann | aPresentation status: nil ].
	eyeseeCanvas := aPresentation canvas.
	canvasScrollPane scroller addMorph: eyeseeCanvas! !

!GLMMorphicEyeSeeRenderer methodsFor: 'rendering' stamp: 'TudorGirba 4/12/2011 10:25'!
render: aPresentation
	canvasScrollPane := ScrollPane new.
	self eyeseeCanvasFor: aPresentation.
	canvasScrollPane
		color: Color white;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	aPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdate: to: self.
	aPresentation on: GLMContextChanged send: #actOnContextChanged: to: self.
	^ canvasScrollPane! !

GLMPresentation subclass: #GLMEyeSeePresentation
	instanceVariableNames: 'renderer canvas diagramBlock eyeSeeRenderer selectedElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-EyeSee-Presentations'!

!GLMEyeSeePresentation methodsFor: 'accessing' stamp: 'TudorGirba 4/12/2011 10:36'!
canvas
	^ canvas! !

!GLMEyeSeePresentation methodsFor: 'accessing' stamp: 'TudorGirba 4/12/2011 10:36'!
canvas: anObject
	canvas := anObject! !

!GLMEyeSeePresentation methodsFor: 'accessing' stamp: 'TudorGirba 6/5/2013 22:22'!
defaultActions
	self
		act: [ :eyesee | eyesee canvas exportAsPNG ] 
			entitled: 'Export as PNG'! !

!GLMEyeSeePresentation methodsFor: 'accessing' stamp: 'TudorGirba 4/12/2011 10:08'!
diagram
	^ diagramBlock ! !

!GLMEyeSeePresentation methodsFor: 'accessing' stamp: 'TudorGirba 4/12/2011 10:08'!
diagram: aBlock
	"use this one to set the "
	diagramBlock := aBlock! !

!GLMEyeSeePresentation methodsFor: 'accessing' stamp: 'TudorGirba 4/12/2011 10:28'!
eyeseeRenderer
	^ eyeSeeRenderer ifNil: [ eyeSeeRenderer := ESDiagramRenderer new]! !

!GLMEyeSeePresentation methodsFor: 'accessing' stamp: 'TudorGirba 4/12/2011 10:29'!
eyeseeRenderer: anESDiagramRenderer
	eyeSeeRenderer := anESDiagramRenderer! !

!GLMEyeSeePresentation methodsFor: 'initialize-release' stamp: 'TudorGirba 6/5/2013 23:15'!
initialize
	super initialize.
	self defaultActions! !

!GLMEyeSeePresentation methodsFor: 'rendering' stamp: 'TudorGirba 4/12/2011 10:23'!
renderGlamorouslyOn: aRenderer
	self registerAnnouncements.
	^aRenderer renderEyeSeePresentation: self! !

!GLMEyeSeePresentation methodsFor: 'accessing' stamp: 'TudorGirba 4/12/2011 10:22'!
renderOn: aRenderer
	self flag: 'find a smarter solution that does not depend on isKindOf:'. 
	self diagram glamourValue: (
		(self entity isKindOf: GLMMultiValue) 
				ifTrue: [(GLMMultiValue with: aRenderer) , self entity , (GLMMultiValue with: self)] 
				ifFalse: [GLMMultiValue with: aRenderer with: self entity with: self]).
	self canvas: aRenderer canvas! !

!GLMEyeSeePresentation methodsFor: 'accessing' stamp: 'AndreHora 4/27/2011 13:35'!
selectedElement 

	^ selectedElement ! !

!GLMEyeSeePresentation methodsFor: 'accessing' stamp: 'AndreHora 4/27/2011 13:35'!
selectedElement: anElement

	^ selectedElement := anElement ! !

Object subclass: #GLMEyeSeeExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-EyeSee-Presentations'!

!GLMEyeSeeExample methodsFor: 'as yet unclassified' stamp: 'TudorGirba 4/23/2014 22:15'!
eyeseeBarDiagram
	<glmBrowser: 'EyeSee interactive bar chart' input: '#(5 2 10 6 12 8)'>
	"self new eyeseeBarDiagram openOn: #(5 2 10 6 12 8)."
	| browser |

	browser := GLMTabulator new.
	browser row: #one span: 3; row: #two.
	browser transmit to: #one; andShow: [:a |
	       a eyesee
			title: 'Sample bar chart';
			diagram: [:renderer :x |
	                       renderer verticalBarDiagram
						y: #yourself;
						models: x;
						width: 200;
						height: 150;
						baseAxisLine.
					renderer interaction popupText: #yourself ]].
	browser transmit from: #one; to: #two; andShow: [:a | 
		a text
			title: 'Preview'].
	^ browser! !
